import com.Components.AdvancedButton;
import gfx.controls.Slider;
import gfx.core.UIComponent;

class DamagePane.UI.OptionsWindow extends UIComponent
{
	var m_timeout:Slider;
	var m_timeoutValue:TextField;

	var m_alpha:Slider;
	var m_alphaValue:TextField;

	var m_smooth:Slider;
	var m_smoothValue:TextField;

	var m_CloseButton:AdvancedButton;
	
	public function OptionsWindow() 
	{
		m_timeout.addEventListener("change", this, "OnTimeoutChanged");
		m_alpha.addEventListener("change", this, "OnAlphaChanged");
		m_smooth.addEventListener("change", this, "OnSmoothChanged");

		m_CloseButton.SignalButtonSelected.Connect(CloseWindow, this);
	}
	
	private function CloseWindow():Void 
	{
		this._visible = false;
	}
	
	private function OnTimeoutChanged(event:Object):Void
	{
		Statistics.Timeout = m_timeout.value;
		m_timeoutValue.text = string(m_timeout.value);
	}

	private function OnSmoothChanged(event:Object):Void
	{
		Statistics.Smooth = m_smooth.value;
		m_smoothValue.text = string(m_smooth.value);
	}
	
	private function OnAlphaChanged(event:Object):Void
	{
		DPSWindow.Instance._alpha = m_alpha.value;
		m_alphaValue.text = string(m_alpha.value);
	}
	
}