import com.Components.AdvancedButton;
import com.GameInterface.Tooltip.TooltipUtils;

/**
 * ...
 * @author Xxx
 */
class DetailPane extends MovieClip
{
	public static var MODE_CRIT: Number = 0;
	public static var MODE_Penetration: Number = 1;
	public static var MODE_Glance: Number = 2;
	public static var MODE_Block: Number = 3;
	public static var MODE_Evade: Number = 4;
	public static var MODES_COUNT: Number = 5;
	
	private var m_title: TextField;
	private var m_1: InfoLine;
	private var m_2: InfoLine;
	
	private var m_NextButton:AdvancedButton;
	private var m_PrevButton:AdvancedButton;
	private var m_mode: Number;
	
	public function DetailPane() 
	{
		super();
		
		m_mode = MODE_CRIT;
		m_title.text = getModeName();
	}
	
	public function onLoad() {
		m_NextButton.SignalButtonSelected.Connect(NextMode, this);
		m_PrevButton.SignalButtonSelected.Connect(PrevMode, this);
	}
	
	private function NextMode():Void 
	{
		m_mode++;
		if (m_mode >= MODES_COUNT)
			m_mode = MODE_CRIT;

		m_title.text = getModeName();
	}

	private function PrevMode():Void 
	{
		m_mode--;
		if (m_mode < 0)
			m_mode = MODES_COUNT-1;

		m_title.text = getModeName();
	}
	
	private function getModeName():String
	{
		switch(m_mode)
		{
			case MODE_CRIT:
				return "Crit";
			case MODE_Penetration:
				return "Penetration";
			case MODE_Block:
				return "Block";
			case MODE_Glance:
				return "Glance";
			case MODE_Evade:
				return "Evade";
		}
		return "???";
	}
	
	public function update(stat:Statistics):Void 
	{
		switch(m_mode)
		{
			case MODE_CRIT:
			{
				m_1.label = "Rate: ";
				m_1.value = stat.damageCritRate + "%";
				m_2.label = "Dealt: ";
				m_2.value = stat.damageCritDealt + " / " + stat.damageCritDealtPercent + "%";
				m_1.tooltip = "Percentage of critical hits from total count";
				m_2.tooltip = "Critical damage / percentage of critical damage from total damage";
				break;
			}
			case MODE_Penetration:
			{
				m_1.label = "Rate: ";
				m_1.value = stat.damagePenRate + "%";
				m_2.label = "Dealt: ";
				m_2.value = stat.damagePenDealt + " / " + stat.damagePenDealtPercent + "%";
				m_1.tooltip = "Percentage of penetrated hits from total count";
				m_2.tooltip = "Damage done by penetrated hits / percentage of this damage from total damage";
				break;
			}
			case MODE_Block:
			{
				m_1.label = "Self: ";
				m_1.value = stat.damageSelfBlockedPercent + "% / " + stat.damageSelfBlocked;
				m_2.label = "Target: ";
				m_2.value = stat.damageTargetBlockedPercent + "% / " + stat.damageTargetBlocked;
				m_1.tooltip = "Percentage of hits blocked by you / hits count";
				m_2.tooltip = "Percentage of hits blocked by your opponent / hits count";
				break;
			}
			case MODE_Glance:
			{
				m_1.label = "Done: ";
				m_1.value = stat.damageGlanceDonePercent + "% / " + stat.damageGlanceDone;
				m_2.label = "Recieved: ";
				m_2.value = stat.damageGlanceRecievedPercent + "% / " + stat.damageGlanceRecieved;
				m_1.tooltip = "Percentage of your glancing hits / hits count";
				m_2.tooltip = "Percentage of received glancing hits / hits count";
				break;
			}
			case MODE_Evade:
			{
				m_1.label = "Self: ";
				m_1.value = stat.damageSelfEvadePercent + "%";
				m_2.label = "Target: ";
				m_2.value = stat.damageTargetEvadePercent + "%";
				m_1.tooltip = "Percentage of attacks from which you evaded";
				m_2.tooltip = "Percentage of attacks from which your opponent evaded";
				break;
			}
		}
	}
	
	public function round(val:Number):Number
	{
		return int(val*100)/100;
	}
	
}

