/**
 * ...
 * @author Xxx
 */
dynamic class StatInfo
{
	public function StatInfo() 
	{
	}

	// const
	public function get timeout():Number
	{
		return Statistics.Timeout;
	}
	
	public function get smooth():Number
	{
		return Statistics.Smooth;
	}
	
	public var total:Number = 0;
	public var count:Number = 0;
	private var _time:Number = 0;
	private var _last:Number = 0;
	
	private var accTime : Number = 0;
	private var perSecAcc : Number = 0;
	private var perSecTimeAcc : Number = 0;
	private var last_perSecAcc : Number = 0;
	private var last_perSecTimeAcc : Number = 0;
	private var perSecHistory : Array = [];
	
	private function reset():Void 
	{
		_time = 0;
		total = 0;
		count = 0;
		
		accTime = 0;
		perSecAcc = 0;
		perSecTimeAcc = 0;
		perSecHistory = [];
	}

	public function update(rec:StatRecord, time:Number):Void 
	{
		var elapsed:Number = time - _last;
		
		_time += elapsed;
		perSecTimeAcc += elapsed;
			
		if (!isActive(elapsed))
			reset();
		
		var damage:Number = (rec.damage - rec.absorb);
		
		count++;
		total += damage;
		
		accTime += elapsed;
		perSecAcc += damage;
		
		if (accTime >= 1.0)
		{
			accTime = 0.0;
			var history:DpsHistoryRecord = new DpsHistoryRecord(perSecTimeAcc, perSecAcc);
			
			if (perSecHistory.length > 0)
			{
				history.value -= last_perSecAcc;
				history.time -= last_perSecTimeAcc;
			}
			perSecHistory.push(history);
			
			if (perSecHistory.length > smooth)
			{
				var oldest:DpsHistoryRecord = DpsHistoryRecord(perSecHistory.shift());
				perSecAcc -= oldest.value;
				perSecTimeAcc -= oldest.time;
			}
			last_perSecAcc = perSecAcc;
			last_perSecTimeAcc = perSecTimeAcc;
		}
		// save last event time
		_last = time;
	}
	
	public function get avarage():Number
	{
		if(_time > 0.0)
			return total / _time;
		return 0.0
	}
	
	public function get time():Number 
	{
		return _time;
	}
	
	public function getPersec():Number
	{
		if(perSecTimeAcc > 0.0)
			return perSecAcc / perSecTimeAcc;
		return 0.0;
	}
	
	private function isActive(elapsed:Number):Boolean
	{
		return elapsed < this.timeout;
	}
	
}